format PE GUI 4.0
entry Start

include '%finc%/win32/win32a.inc'

include "%finc%/libs/msgutils.inc"
include "%finc%/libs/tform.inc"
include "%finc%/libs/parents.inc"
include "%finc%/libs/templates.inc"

include "%finc%/libs/msgutils.asm"
include "%finc%/libs/tform.asm"
include "%finc%/libs/parents.asm"
include "%finc%/libs/templates.asm"

options.Threads = 0

include "%lib%/simpledebug/debug.asm"

include "%lib%/system/memory.asm"
include "%lib%/data/arrays.asm"
include "%lib%/data/strlib.asm"


include "MainForm.frm"

uglobal
  hInstance dd ?
  hHeap     dd ?
  hMainForm dd ?
endg

Start:
        invoke  GetModuleHandleA,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

        InitializeAll

        stdcall CreateForm, frmMain, NULL
        xor     eax, eax
        test    ebx, ebx
        jz      .terminate

        mov     [hMainForm], ebx

.run:
        call    ProcessMessages
        jc      .terminate

        invoke  WaitMessage
        jmp     .run

.terminate:
        push    eax
        FinalizeAll
        invoke  ExitProcess ; exit code from the stack.

data import
  include '%finc%/win32/allimports.asm'
end data

IncludeAllGlobals
